#!/bin/bash
#########################################
#                                       #
# Masowa generacja certyfikatow z listy #
#                                       #
#      (c) Piotr Pisz 2009.03.24        #
#########################################
#
# Zmiany:
#
# 2010.02.19 - Dostosowanie do wspolpracy z camenu.sh
#
# TODO: 
# 1. Konwersja DEC/HEX - raczej nie.
# 2. Tarowanie do pliku z listy - zrobione.
# 3. Wysylanie mailem lub inna forma przeslania na serwer docelowy COMP
# 4. Ustalenie czy przy masowej generacji potrzebne sa hasla na kluczach merchantow

PASS=AB1qaz@WSX!
CADIR=/etc/pki/ca
LISTA=${CADIR}/txt/lista.txt
OUTKEY=${CADIR}/key
OUTREQ=${CADIR}/req
OUTCRT=${CADIR}/crt
OUTP12=${CADIR}/p12
OUTCAK=${CADIR}/cak
OUTPAK=${CADIR}/pak
OUTCRL=${CADIR}/crl
OUTCNF=${CADIR}/cnf
CNF=openssl_mass.cnf
SUBJECT="/C=PL/O=PWPW/OU=PULAB/CN="

#Do petli wyzszego rzedu gdy list bedzie wiecej
LINIE=`cat ${LISTA}`

#Masta petla ;)
for LINIA in ${LINIE}
do
    openssl genrsa -out ${OUTKEY}/${LINIA}.key 1024
    openssl req -config ${OUTCNF}/${CNF} -new -subj ${SUBJECT}${LINIA} -key ${OUTKEY}/${LINIA}.key -out ${OUTREQ}/${LINIA}.req
    openssl ca -config ${OUTCNF}/${CNF} -policy policy_user -extensions usr_crt -in ${OUTREQ}/${LINIA}.req -out ${OUTCRT}/${LINIA}.crt -passin pass:${PASS} -notext -batch    
    openssl pkcs12 -export -in ${OUTCRT}/${LINIA}.crt -inkey ${OUTKEY}/${LINIA}.key -certfile ${OUTCAK}/ca.crt -out ${OUTP12}/${LINIA}.p12 -passout pass:${PASS}
    ls -1 ${OUTKEY}/${LINIA}.key >> ${OUTPAK}/pary.txt
    ls -1 ${OUTCRT}/${LINIA}.crt >> ${OUTPAK}/pary.txt
    ls -1 ${OUTP12}/${LINIA}.p12 >> ${OUTPAK}/pary.txt
done

openssl ca -config ${OUTCNF}/${CNF} -gencrl -out ${OUTCRL}/crl.pem -passin pass:${PASS} -batch
tar cf ${OUTPAK}/pack.tar -I ${OUTPAK}/pary.txt

